diff -NaurdbB -xCVS lsqrms-2.0.4b.old/src/main.c lsqrms-2.0.4b/src/main.c
--- lsqrms-2.0.4b.old/src/main.c	Wed Apr 16 18:33:17 EDT 2003
+++ lsqrms-2.0.4b/src/main.c	Sun Feb 24 22:49:49 EST 2008
@@ -465,175 +953,568 @@
 	 }
  }
 
- ret_val = dyn_pr_n2(s, iOpnPen, iExtPen, jOpnPen, jExtPen, rows, cols,
+      (void)dyn_pr_n2(ss, iOpnPen, iExtPen, jOpnPen, jExtPen,
+		      r_num_que, r_num_tar, rows, cols,
                      SS,  TrRow,   TrCol, &iOverallMax, &jOverallMax); 
 
+      nbrks_old = nbrks;
  nbrks = -1;
 
- nEqPairs_sav = nEqPairs;
- nEqPairs = TrMat2Equivalences (rows,cols,TrRow,TrCol,
-	                            iOverallMax,jOverallMax,iina,jinb,&nbrks);
+      nEqPairs_old = nEqPairs;
+      quality_old = quality;
+      nEqPairs = TrMat2Equivalences(rows,cols,TrRow,TrCol,
+				    iOverallMax,jOverallMax,
+				    iina,jinb,&nbrks);
 
- str1 = (CoordType *) malloc(nEqPairs * sizeof(CoordType));
- str2 = (CoordType *) malloc(nEqPairs * sizeof(CoordType));
+      if (use_carbonyl)
+	nEqPairs = 4*(floor((double)nEqPairs/4.0));
 
- for(i=0;i<nEqPairs;i++) {
-   str1[i].x = x_que[1][iina[i]-1]; str2[i].x = x_tar[1][jinb[i]-1];
-   str1[i].y = x_que[2][iina[i]-1]; str2[i].y = x_tar[2][jinb[i]-1];
-   str1[i].z = x_que[3][iina[i]-1]; str2[i].z = x_tar[3][jinb[i]-1];		
+      str1 = (CoordType *)malloc(nEqPairs * sizeof(CoordType));
+      if (!str1) {
+	fprintf(stderr,"main: Allocation failed!\n");
+	exit(1);
  }
+      str2 = (CoordType *)malloc(nEqPairs * sizeof(CoordType));
+      if (!str2) {
+	fprintf(stderr,"main: Allocation failed!\n");
+	exit(1);
+      }
+
+      for (i=0; i<nEqPairs; i++) {
+	str1[i].x = x_que[1][iina[i]-1];
+	str2[i].x = x_tar[1][jinb[i]-1];
+
+	str1[i].y = x_que[2][iina[i]-1];
+	str2[i].y = x_tar[2][jinb[i]-1];
+
+	str1[i].z = x_que[3][iina[i]-1];
+	str2[i].z = x_tar[3][jinb[i]-1];
+      }
 
+      RMSold = RMS;
  RMS = bestfit(U, T, str1, str2, nEqPairs); 
- printf("RMS, eq.pairs = %f %d\n",RMS,nEqPairs);
+      if (RMS > 0.01)
+	quality = fsqrt(nEqPairs)/RMS;
+      else
+	quality = 100*fsqrt(nEqPairs);
+      printf("RMS, eq.pairs, quality = %f %d %f\n",RMS,nEqPairs,quality);
 
- ret_val = rotrans(x_que, rows, U, T);
+      (void)rotrans(x_que, rows, U, T);
 
- if( RMS < RMSmin ) {
+      /* expected increase in RMS is proportional to square root of chain
+	 length - Allen */
+
+      if ((RMS < RMSmin) || 
+	  ((quality > quality_sav) && ((RMS < BAD_THRESH) ||
+				       (RMS == RMSmin))) ||
+	  ((nEqPairs_sav < 0) &&
+	   ((nEqPairs > nEqPairs_old) || (quality >= quality_sav) ||
+	    (RMS <= RMSsav) ||
+	    ((nEqPairs < nEqPairs_old) && (quality < quality_sav) &&
+	     (total_OpnPen < 10)))) ||
+	  ((nbrks < nbrks_sav) && (quality_sav <= quality) &&
+	   ((RMS < BAD_THRESH) || (RMS <= RMSsav))) ||
+	  ((nEqPairs_sav < nEqPairs) &&
+	   ((RMS < BAD_THRESH) || (RMS <= RMSmin)) &&
+	   ((RMS - RMSsav) < 0.1))) {
+	if ((nEqPairs_sav < 0) && (nEqPairs < nEqPairs_old) &&
+	    (quality < quality_sav) && (total_OpnPen < 10) &&
+	    ((RMS > RMSsav) || (RMSsav < BAD_THRESH))) {
+	  /* increase gap penalties -
+	     ratio of 1/0.05 btwn Opn and Ext == Structal original
+	     of 10/0.5 */
+	  again = 1;
+	  again2 = 1;
+	  increased_gap_penalties = 1;
+	  printf("Increasing gap penalties\n");
+	  total_OpnPen++; /* Should thresh of 10 be adjusted for changes in
+			     structal formula constants? XXX */
+	  for (j=1; j < (cols-1); j++) {
+	    jOpnPen[j]++;
+	    jExtPen[j] += 0.05;
+	  }
+	  for (i=1; i < (rows-1); i++) {
+	    iOpnPen[i]++;
+	    iExtPen[i] += 0.05;
+	  }
+	} else if (((quality > quality_sav) && ((RMS < BAD_THRESH) ||
+						(RMS <= RMSsav))) ||
+		   ((nEqPairs_sav < 0) && ((nEqPairs > nEqPairs_old) ||
+					   (quality >= quality_sav) ||
+					   ((nEqPairs == nEqPairs_old) &&
+					    (RMS <= RMSsav)))) ||
+		   ((nbrks < nbrks_sav) && (quality_sav <= quality) &&
+		    ((RMS < BAD_THRESH) || (RMS <= RMSsav))) ||
+		   ((nEqPairs_sav < nEqPairs) &&
+		    ((RMS < BAD_THRESH) || (RMS <= RMSmin)) &&
+		    ((RMS - RMSsav) < 0.1))) {
+	  if (nEqPairs_sav < 0) {
+	    again = 1;
+	    if (((quality_sav - quality) >= 0.5) ||
+		((quality < quality_sav) &&
+		 (nEqPairs < nEqPairs_old))) {
+	      printf("Structal method may have failed\n");
+	      again2 = 1;
+	    }
+	  }
+	  if (quality > quality_max)
+	    quality_max = quality;
+	  quality_sav = quality;
+	  RMSsav = RMS;
+	  nEqPairs_sav = nEqPairs;
+	  nbrks_sav = nbrks;
+	  sav_updated = 1;
+	  if (RMS < RMSmin) {
    RMSmin = RMS;
-   for(i=0; i<rows; i++) {
+	    again = 1;
+	  } else if (RMS == RMSmin)
+	    again = 1;
+
+	  for (i=0; i<rows; i++) {
      x_que_sav[1][i] = x_que[1][i]; 
      x_que_sav[2][i] = x_que[2][i]; 
      x_que_sav[3][i] = x_que[3][i]; 
    }
-   for(i=0;i<=MAXSEQ;i++) {
+	  for (i=0; i<=MAXSEQ; i++) {
+	    iina_sav[i] = iina[i];
+	    jinb_sav[i] = jinb[i];
+	  }
+	} else if ((quality_sav == quality) ||
+		   ((RMSmin >= BAD_THRESH) && (RMS < RMSsav)) ||
+		   ((((quality_max - quality) < 0.001) ||
+		     (((quality_max - quality) < 0.5) &&
+		      (total_OpnPen >= 10))) &&
+		    ((RMSmin - RMS) >= 0.1))) {
+	  again = 1;
+	  RMSmin = RMS;
+	  RMSsav = RMS;
+	  quality_sav = quality;
+	  nEqPairs_sav = nEqPairs;
+	  nbrks_sav = nbrks;
+	  sav_updated = 1;
+	  for (i=0; i<rows; i++) {
+	    x_que_sav[1][i] = x_que[1][i]; 
+	    x_que_sav[2][i] = x_que[2][i]; 
+	    x_que_sav[3][i] = x_que[3][i]; 
+	  }
+	  for (i=0; i<=MAXSEQ; i++) {
      iina_sav[i] = iina[i];
      jinb_sav[i] = jinb[i];
    }
+	} else { /* increase gap penalties -
+		    ratio of 1/0.05 btwn Opn and Ext == Structal original
+		    of 10/0.5 */
+	  again = 1;
+	  again2 = 1;
+	  increased_gap_penalties = 1;
+	  printf("Increasing gap penalties\n");
+	  total_OpnPen++;
+	  for (j=1; j < (cols-1); j++) {
+	    jOpnPen[j]++;
+	    jExtPen[j] += 0.05;
+	  }
+	  for (i=1; i < (rows-1); i++) {
+	    iOpnPen[i]++;
+	    iExtPen[i] += 0.05;
+	  }
+	}
  }
 
+      if (nEqPairs_sav < 0) {
+	if (increased_gap_penalties)
+	  stay = 1;
+	else {
+	  printf("Structal method unsuccessful\n");
+	  RMSmin = RMSold;
+	  RMSsav = RMSold;
+	  quality_sav = quality_old;
+	  nEqPairs_sav = nEqPairs_old;
+	  nbrks_sav = nbrks_old;
+	  for (i=0; i<rows; i++) {
+	    x_que_sav[1][i] = x_que_old[1][i]; 
+	    x_que_sav[2][i] = x_que_old[2][i]; 
+	    x_que_sav[3][i] = x_que_old[3][i]; 
+	  }
+	  for (i=0; i<=MAXSEQ; i++) {
+	    iina_sav[i] = iina_old[i];
+	    jinb_sav[i] = jinb_old[i];
+	  }
+	}
+      } else if ((nEqPairs == nEqPairs_old) ||
+		 (nEqPairs == nEqPairs_sav)) {
+	stay = check_eq(iina,jinb,iina_old,jinb_old,
+			MIN(nEqPairs,nEqPairs_old));
+	if (stay && (! sav_updated) && (! again2) &&
+	    (nEqPairs == nEqPairs_sav) && (iter > 1)) {
+	  if (! check_eq(iina,jinb,iina_sav,jinb_sav,
+			 MIN(nEqPairs,nEqPairs_sav)))
+	    stay = 0;
+	}
 
- if( !(nEqPairs-nEqPairs_sav) ) {
-	 stay = check_eq(iina,jinb,iina_sav,jinb_sav,nEqPairs);
+	if (again2) {
+	  if ((! stay) && (iter > 1) && (! increased_gap_penalties))
+	    printf("Doing again despite equal pairs (again2 is 1)\n");
+	  stay = 1;
+	} else if (again) {
+	  if ((! stay) && (iter > 1)) {
+	    if ((fabs(U[0][0]-1) >= epsilon2) ||
+		(fabs(U[0][1]) >= epsilon2) ||
+		(fabs(U[0][2]) >= epsilon2) ||
+		(fabs(U[1][0]) >= epsilon2) ||
+		(fabs(U[1][1]-1) >= epsilon2) ||
+		(fabs(U[1][2]) >= epsilon2) ||
+		(fabs(U[2][0]) >= epsilon2) ||
+		(fabs(U[2][1]) >= epsilon2) ||
+		(fabs(U[2][2]-1) >= epsilon2) ||
+		(fabs(T[0]) >= epsilon2) ||
+		(fabs(T[1]) >= epsilon2) ||
+		(fabs(T[2]) >= epsilon2)) {
+	      printf("Doing again despite equal pairs\n");
+	      stay = 1;
+	    }
+	  } else
+	    stay = 1;
+	} else {
+	  if (stay && (iter > 1) &&
+	      (fabs(U[0][0]-1) < epsilon) &&
+	      (fabs(U[0][1]) < epsilon) &&
+	      (fabs(U[0][2]) < epsilon) &&
+	      (fabs(U[1][0]) < epsilon) &&
+	      (fabs(U[1][1]-1) < epsilon) &&
+	      (fabs(U[1][2]) < epsilon) &&
+	      (fabs(U[2][0]) < epsilon) &&
+	      (fabs(U[2][1]) < epsilon) &&
+	      (fabs(U[2][2]-1) < epsilon) &&
+	      (fabs(T[0]) < epsilon2) &&
+	      (fabs(T[1]) < epsilon2) &&
+	      (fabs(T[2]) < epsilon2)) {
+	    /* prevent getting stuck - Allen */
+	    for (i = (stay-1); (i <= nEqPairs) && (i <= nEqPairs_old); i++) {
+	      if (isascii(a_que[iina_old[i]-1]) &&
+		  isascii(a_que[iina[i]-1]) &&
+		  (! islower(a_que[iina_old[i]-1])) &&
+		  (! islower(a_que[iina[i]-1])) &&
+		  isascii(a_tar[jinb_old[i]-1]) &&
+		  isascii(a_tar[jinb[i]-1]) &&
+		  (! islower(a_tar[jinb_old[i]-1])) &&
+		  (! islower(a_tar[jinb[i]-1])) &&
+		  ((iina[i] != iina_old[i]) || (jinb[i] != jinb_old[i]))) {
+		printf("Looping; old:  %5d %c%c%c %4d :  %5d  :  %5d %c%c%c %4d\n",
+		       iina_old[i], aa_que[iina_old[i]-1][0],
+		       aa_que[iina_old[i]-1][1],
+		       aa_que[iina_old[i]-1][2], 
+		       r_num_que[iina_old[i]-1],
+		       i,
+		       jinb_old[i], aa_tar[jinb_old[i]-1][0],
+		       aa_tar[jinb_old[i]-1][1],
+		       aa_tar[jinb_old[i]-1][2],
+		       r_num_tar[jinb_old[i]-1]);
+		printf("Looping; new:  %5d %c%c%c %4d :  %5d  :  %5d %c%c%c %4d\n",
+		       iina[i], aa_que[iina[i]-1][0],
+		       aa_que[iina[i]-1][1],
+		       aa_que[iina[i]-1][2], r_num_que[iina[i]-1],
+		       i,
+		       jinb[i], aa_tar[jinb[i]-1][0],
+		       aa_tar[jinb[i]-1][1],
+		       aa_tar[jinb[i]-1][2],
+		       r_num_tar[jinb[i]-1]);
+		if (((quality_old - quality) >= 0.5) ||
+		    ((RMSold >= BAD_THRESH) && ((RMS - RMSold) >= 0.1)) ||
+		    ((RMSold < BAD_THRESH) && (quality_old > quality)) ||
+		    ((quality_sav - MAX(quality,quality_old)) >= 0.5) ||
+		    ((RMSsav >= BAD_THRESH) &&
+		     ((MIN(RMS,RMSold) - RMSsav) >= 0.1)) ||
+		    ((RMSsav < BAD_THRESH) &&
+		     (quality_sav > MAX(quality,quality_old))))
+		  break;
+	      }
+	    }
+	    stay = 0;
  }
+	}
+      }
 
- free( (RELEASE) (str1) );
- free( (RELEASE) (str2) );
+      free((RELEASE)(str1));
+      free((RELEASE)(str2));
 
+      for (i=0; i<=MAXSEQ; i++) {
+	iina_old[i] = iina[i];
+	jinb_old[i] = jinb[i];
+      }
+      
  free_iVector(iina,0, MAXSEQ);
  free_iVector(jinb,0, MAXSEQ);
 
-} while(stay > 0 && iter < 100); /* End of iteration cycle */
- } /* if(structal) */
+      fflush(NULL);
 
- printf("RMSmin = %f \n",RMSmin);
+    } while(stay > 0 && iter < 100); /* End of iteration cycle */
+  } /* if(!lsq) */
 
-/* Performing back-transformation of BOTH structures (QUERY will still be PMI-aligned!): */
- ret_val = FormRotMatrX(Rtemp,angle_c_tar);
- ret_val = TRmoveXYZstruc(Tzero,Rtemp,x_que,rows);
- ret_val = TRmoveXYZstruc(Tzero,Rtemp,x_tar,cols);
- ret_val = FormRotMatrY(Rtemp,angle_b_tar); 
- ret_val = TRmoveXYZstruc(Tzero,Rtemp,x_que,rows);
- ret_val = TRmoveXYZstruc(Tzero,Rtemp,x_tar,cols);
- ret_val = TRmoveXYZstruc(Tcm_tar,Runity,x_que,rows);
- ret_val = TRmoveXYZstruc(Tcm_tar,Runity,x_tar,cols);
+  printf("RMSmin = %f\n",RMSmin);
+  printf("quality_max = %f\n", quality_max);
 
-/* CHECK COORDINATES: */
-/*
- stream = fopen( "rot_query.dat", "w" );
- if( stream == NULL )
-   printf( "Couldn't open file rot_query.dat\n" );
+  /* Performing back-transformation of BOTH structures
+     (QUERY will still be PMI-aligned!): */
+  (void)FormRotMatrX(Rtemp,angle_c_tar);
+  (void)TRmoveXYZstruc(Tzero,Rtemp,x_que,rows);
+  printf("Rotating query: x-angle %.10f; %.1f %.1f %.1f; %.1f %.10f %.10f; %.1f %.10f %.10f\n",
+	 angle_c_tar,
+	 Rtemp[1][1],Rtemp[1][2],Rtemp[1][3],
+	 Rtemp[2][1],Rtemp[2][2],Rtemp[2][3],
+	 Rtemp[3][1],Rtemp[3][2],Rtemp[3][3]);
+  (void)TRmoveXYZstruc(Tzero,Rtemp,x_tar,cols);
+  (void)FormRotMatrY(Rtemp,angle_b_tar); 
+  (void)TRmoveXYZstruc(Tzero,Rtemp,x_que,rows);
+  printf("Rotating query: y-angle %.10f; %.10f %.1f %.10f; %.1f %.1f %.1f; %.10f %.1f %.10f\n",
+	 angle_b_tar,
+	 Rtemp[1][1],Rtemp[1][2],Rtemp[1][3],
+	 Rtemp[2][1],Rtemp[2][2],Rtemp[2][3],
+	 Rtemp[3][1],Rtemp[3][2],Rtemp[3][3]);
+  (void)TRmoveXYZstruc(Tzero,Rtemp,x_tar,cols);
+  (void)TRmoveXYZstruc(Tcm_tar,Runity,x_que,rows);
+  printf("Moving query: %.10f %.10f %.10f\n",
+	 Tcm_tar[1], Tcm_tar[2], Tcm_tar[3]);
+  (void)TRmoveXYZstruc(Tcm_tar,Runity,x_tar,cols);
+
+  /* CHECK COORDINATES: */
+/*   stream = fopen("rot_query.dat", "w"); */
+/*   if (stream == NULL) */
+/*     perror("main: Couldn't open file rot_query.dat"); */
+/*   else { */
+/*     for (i=0; i<rows; i++) { */
+/*       fprintf(stream, "%4s%7d%4s  %c%c%c %1s%4d%12.3f %8.3f %8.3f\n", */
+/* 	      "ATOM",i+1,"CA",aa_que[i][0], aa_que[i][1], aa_que[i][2],"L", */
+/* 	      i+1,x_que[1][i],  x_que[2][i], x_que[3][i]); */
+/*     } */
+/*     fclose(stream); */
+/*   } */
+
+  if (lsq)
+    nEqPairs_sav = nEqPairs;
+
+  printf("Final: RMS, eq.pairs, quality = %f %d %f\n",
+	 RMSsav,nEqPairs_sav,quality_sav);
+
+  fflush(NULL);
+
+  if (structal) {  /* STRUCTAL-LIKE OUTPUT */
+    stream = fopen(structal_out, "w");
+    if (stream == NULL)
+      fprintf(stderr, "main: Couldn't open file %s: %s", structal_out,
+	      strerror(errno));
  else {
-   for(i=0;i<rows;i++) {
-	  fprintf( stream, "%4s%7d%4s  %c%c%c %1s%4d%12.3f %8.3f %8.3f\n", "ATOM",i+1,"CA",
-		  aa_que[i][0], aa_que[i][1], aa_que[i][2],"L",i+1,
-		  x_que[1][i],  x_que[2][i], x_que[3][i]);
+      fprintf(stream, "DUMP rmsnoe   %f (RMS deviation, before elim. bad)\n",
+	      RMSsav);
+      /*
+	EQUIV i seqai : k : j seqaj ja
+	EQUIV   105 GLN  105  :    86 :     98 VAL   98
+      */  
+      fprintf(stream, "#EQUIV WHAT i seqa i : j : m seqa m\n");
+      for (i=0; i<nEqPairs_sav; i++) {
+	if (a_que[iina_sav[i]-1] == a_tar[jinb_sav[i]-1])
+	  aa = '*';
+	else
+	  aa = ' ';
+	if (use_carbonyl && (! isascii(a_que[iina_sav[i]-1]))) {
+	  if (islower(toascii(a_que[iina_sav[i]-1]))) {
+	    fprintf(stream,
+	       "EQUIV C   %5d %c%c%c %c %4d :  %5d  : %c  %5d %c%c%c %4d %c\n",
+		    iina_sav[i],aa_que[iina_sav[i]-1][0],
+		    aa_que[iina_sav[i]-1][1],
+		    aa_que[iina_sav[i]-1][2],
+		    _toupper(toascii(a_que[iina_sav[i]-1])),
+		    r_num_que[iina_sav[i]-1],
+		    i+1,_toupper(toascii(a_tar[jinb_sav[i]-1])),
+		    jinb_sav[i],
+		    aa_tar[jinb_sav[i]-1][0], aa_tar[jinb_sav[i]-1][1],
+		    aa_tar[jinb_sav[i]-1][2], 
+		    r_num_tar[jinb_sav[i]-1], aa);
+	  } else {
+	    fprintf(stream,
+	       "EQUIV N   %5d %c%c%c %c %4d :  %5d  : %c  %5d %c%c%c %4d %c\n",
+		    iina_sav[i],aa_que[iina_sav[i]-1][0],
+		    aa_que[iina_sav[i]-1][1],
+		    aa_que[iina_sav[i]-1][2], toascii(a_que[iina_sav[i]-1]),
+		    r_num_que[iina_sav[i]-1],
+		    i+1, toascii(a_tar[jinb_sav[i]-1]), jinb_sav[i],
+		    aa_tar[jinb_sav[i]-1][0], aa_tar[jinb_sav[i]-1][1],
+		    aa_tar[jinb_sav[i]-1][2],
+		    r_num_tar[jinb_sav[i]-1], aa);
    }
-   fclose( stream );
+	} else if (use_carbonyl && islower(a_que[iina_sav[i]-1])) {
+	  fprintf(stream,
+	       "EQUIV O   %5d %c%c%c %c %4d :  %5d  : %c  %5d %c%c%c %4d %c\n",
+		  iina_sav[i],aa_que[iina_sav[i]-1][0],
+		  aa_que[iina_sav[i]-1][1],
+		  aa_que[iina_sav[i]-1][2], _toupper(a_que[iina_sav[i]-1]),
+		  r_num_que[iina_sav[i]-1],
+		  i+1, _toupper(a_tar[jinb_sav[i]-1]), jinb_sav[i],
+		  aa_tar[jinb_sav[i]-1][0], aa_tar[jinb_sav[i]-1][1],
+		  aa_tar[jinb_sav[i]-1][2],
+		  r_num_tar[jinb_sav[i]-1], aa);
+	} else {
+	  fprintf(stream,
+	       "EQUIV CA  %5d %c%c%c %c %4d :  %5d  : %c  %5d %c%c%c %4d %c\n",
+		  iina_sav[i],aa_que[iina_sav[i]-1][0],
+		  aa_que[iina_sav[i]-1][1],
+		  aa_que[iina_sav[i]-1][2], a_que[iina_sav[i]-1],
+		  r_num_que[iina_sav[i]-1],
+		  i+1, a_tar[jinb_sav[i]-1], jinb_sav[i],
+		  aa_tar[jinb_sav[i]-1][0], aa_tar[jinb_sav[i]-1][1],
+		  aa_tar[jinb_sav[i]-1][2],
+		  r_num_tar[jinb_sav[i]-1], aa);
  }
-*/
- stream = fopen( "que.dat", "w" );
- if( stream == NULL )
-   printf( "Couldn't open file que.dat\n" );
- else {
-   fprintf( stream, "%d\n", rows);
-   for(i=0;i<rows;i++) { 
-      fprintf( stream, "%8.3f %8.3f %8.3f\n", x_que[1][i], x_que[2][i], x_que[3][i]);
    }
-   fclose( stream );
+      fprintf(stream, "#EQUIV DONE\n\n");
+      fprintf(stream, "IXYZ x_oldk, str. 1 original (PDB standard format)\n");
+      for (i=0; i<rows; i++) {
+	if (use_carbonyl && (! isascii(a_que[i]))) {
+	  if (islower(toascii(a_que[i]))) {
+	    fprintf(stream,
+		    "ATOM  %5d %4s %c%c%c L%4d    %8.3f%8.3f%8.3f  1.00\n",
+		    i+1," C  ",aa_que[i][0], aa_que[i][1],
+		    aa_que[i][2],
+		    r_num_que[i], x_que_original[1][i],
+		    x_que_original[2][i],
+		    x_que_original[3][i]);
+	  } else {
+	   fprintf(stream,
+		   "ATOM  %5d %4s %c%c%c L%4d    %8.3f%8.3f%8.3f  1.00\n",
+		   i+1," N  ",aa_que[i][0], aa_que[i][1],
+		   aa_que[i][2],
+		   r_num_que[i], x_que_original[1][i],
+		   x_que_original[2][i], x_que_original[3][i]);
  }
-
- if(structal) {  /* STRUCTAL-LIKE OUTPUT */
-   stream = fopen( "structal.out", "w" );
-   if( stream == NULL )
-     printf( "Couldn't open file structal.out\n" );
-   else {
-     fprintf( stream, "DUMP rmsnoe   %f (RMS deviation, before elim. bad)\n", RMSmin);
-     fprintf( stream, "IXYZ x_oldk, str. 1 original (PDB standard format)\n");
-     for(i=0;i<rows;i++) {
-	    fprintf( stream, "%4s%7d%4s  %c%c%c %1s%4d%12.3f %8.3f %8.3f\n", "ATOM",i+1,"CA",
-	    	  aa_que[i][0], aa_que[i][1], aa_que[i][2],"L",i+1,
-		      x_que_original[1][i],  x_que_original[2][i], x_que_original[3][i]);
+       } else if (use_carbonyl && islower(a_que[i])) {
+	 fprintf(stream,
+		 "ATOM  %5d %4s %c%c%c L%4d    %8.3f%8.3f%8.3f  1.00\n",
+		 i+1," O  ",aa_que[i][0], aa_que[i][1], aa_que[i][2],
+		 r_num_que[i],x_que_original[1][i],
+		 x_que_original[2][i],
+		 x_que_original[3][i]);
+       } else {
+	 fprintf(stream,
+		 "ATOM  %5d %4s %c%c%c L%4d    %8.3f%8.3f%8.3f  1.00\n",
+		 i+1," CA ",aa_que[i][0], aa_que[i][1], aa_que[i][2],
+		 r_num_que[i],
+		 x_que_original[1][i],
+		 x_que_original[2][i],
+		 x_que_original[3][i]);
 	 }
-     fprintf( stream, "IXYZ DONE\n\n");
-	 fprintf( stream, "IXYZ x_old, str. 1 rotated (PDB standard format)\n");
-     for(i=0;i<rows;i++) {
-	    fprintf( stream, "%4s%7d%4s  %c%c%c %1s%4d%12.3f %8.3f %8.3f\n", "ATOM",i+1,"CA",
-	    	  aa_que[i][0], aa_que[i][1], aa_que[i][2],"L",i+1,
-		      x_que[1][i],  x_que[2][i], x_que[3][i]);
 	 }
-     fprintf( stream, "IXYZ DONE\n\n");
-	 fprintf( stream, "IXYZ x_new, str. 2 original (PDB standard format)\n");
-     for(i=0;i<cols;i++) {
-	    fprintf( stream, "%4s%7d%4s  %c%c%c %1s%4d%12.3f %8.3f %8.3f\n", "ATOM",i+1,"CA",
-	    	  aa_tar[i][0], aa_tar[i][1], aa_tar[i][2],"L",i+1,
-		      x_tar[1][i],  x_tar[2][i], x_tar[3][i]);
+     fprintf(stream, "IXYZ DONE\n\n");
+     fprintf(stream, "IXYZ x_old, str. 1 rotated (PDB standard format)\n");
+     for (i=0; i<rows; i++) {
+       if (use_carbonyl && (! isascii(a_que[i]))) {
+	 if (islower(toascii(a_que[i]))) {
+	   fprintf(stream,
+		   "ATOM  %5d %4s %c%c%c L%4d    %8.3f%8.3f%8.3f  1.00\n",
+		   i+1," C  ",aa_que[i][0], aa_que[i][1],
+		   aa_que[i][2],
+		   r_num_que[i], x_que[1][i], x_que[2][i],x_que[3][i]);
+	 } else {
+	   fprintf(stream,
+		   "ATOM  %5d %4s %c%c%c L%4d    %8.3f%8.3f%8.3f  1.00\n",
+		   i+1," N  ",aa_que[i][0], aa_que[i][1],
+		   aa_que[i][2],
+		   r_num_que[i], x_que[1][i], x_que[2][i], x_que[3][i]);
 	 }
-     fprintf( stream, "IXYZ DONE\n\n");
-     /*
-     EQUIV i seqai : k : j seqaj ja
-     EQUIV   105 GLN  105  :    86 :     98 VAL   98
-     */  
-     fprintf( stream, "EQUIV i seqa i : k : j seqa j \n");	
-     for(i=0;i<nEqPairs;i++) {	 
-	 fprintf( stream, "EQUIV %5d %c%c%c %4d  : %5d :  %5d  %c%c%c%4d\n",
-		iina_sav[i],
-		aa_que[iina_sav[i]-1][0], aa_que[iina_sav[i]-1][1], aa_que[iina_sav[i]-1][2],
-		iina_sav[i], i,
-		jinb_sav[i],
-	    aa_tar[jinb_sav[i]-1][0], aa_tar[jinb_sav[i]-1][1], aa_tar[jinb_sav[i]-1][2],
-		jinb_sav[i]);
+       } else if (use_carbonyl && islower(a_que[i])) {
+	 fprintf(stream,
+		 "ATOM  %5d %4s %c%c%c L%4d    %8.3f%8.3f%8.3f  1.00\n",
+		 i+1," O  ",aa_que[i][0], aa_que[i][1], aa_que[i][2],
+		 r_num_que[i],x_que[1][i],  x_que[2][i], x_que[3][i]);
+       } else {
+	 fprintf(stream,
+		 "ATOM  %5d %4s %c%c%c L%4d    %8.3f%8.3f%8.3f  1.00\n",
+		 i+1," CA ",aa_que[i][0], aa_que[i][1], aa_que[i][2],
+		 r_num_que[i],x_que[1][i],  x_que[2][i], x_que[3][i]);
 	 }
-     fclose( stream );
    } 
- } /* if(structal) */
+     fprintf(stream, "IXYZ DONE\n\n");
+     fprintf(stream, "IXYZ x_new, str. 2 original (PDB standard format)\n");
+     for (i=0; i<cols; i++) {
+       if (use_carbonyl && (! isascii(a_tar[i]))) {
+	 if (islower(toascii(a_tar[i]))) {
+	   fprintf(stream,
+		   "ATOM  %5d %4s %c%c%c L%4d    %8.3f%8.3f%8.3f  1.00\n",
+		   i+1," C  ",aa_tar[i][0], aa_tar[i][1],
+		   aa_tar[i][2],
+		   r_num_tar[i], x_tar[1][i], x_tar[2][i],x_tar[3][i]);
+	 } else {
+	   fprintf(stream,
+		   "ATOM  %5d %4s %c%c%c L%4d    %8.3f%8.3f%8.3f  1.00\n",
+		   i+1," N  ",aa_tar[i][0], aa_tar[i][1],
+		   aa_tar[i][2],
+		   r_num_tar[i], x_tar[1][i], x_tar[2][i], x_tar[3][i]);
+	 }
+       } else if (use_carbonyl && islower(a_tar[i])) {
+	 fprintf(stream,
+		 "ATOM  %5d %4s %c%c%c L%4d    %8.3f%8.3f%8.3f  1.00\n",
+		 i+1," O  ",aa_tar[i][0], aa_tar[i][1], aa_tar[i][2],
+		 r_num_tar[i],x_tar[1][i],  x_tar[2][i], x_tar[3][i]);
+       } else {
+	 fprintf(stream,
+		 "ATOM  %5d %4s %c%c%c L%4d    %8.3f%8.3f%8.3f  1.00\n",
+		 i+1," CA ",aa_tar[i][0], aa_tar[i][1], aa_tar[i][2],
+		 r_num_tar[i],x_tar[1][i],  x_tar[2][i], x_tar[3][i]);
+       }
+     }
+     fprintf(stream, "IXYZ DONE\n\n");
+     fclose(stream);
+   }
+  } /* if(structal) */ else {
+    stream = fopen("que.dat", "w");
+    if (stream == NULL)
+      perror("main: Couldn't open file que.dat");
+    else {
+      fprintf(stream, "%d\n", rows);
+      for (i=0; i<rows; i++) { 
+	fprintf(stream, "%8.3f %8.3f %8.3f\n",
+		x_que[1][i], x_que[2][i], x_que[3][i]);
+      }
+      fclose(stream);
+    }
+  }
 
-/* FREE ALL ALLOCATED MEMORY: */
- free_iVector(iina_sav,0, MAXSEQ);
- free_iVector(jinb_sav,0, MAXSEQ);
+  /* FREE ALL ALLOCATED MEMORY: */
+  /* Not necessary if returning/exiting from main - Allen */
+/*   free_iVector(iina_sav,0, MAXSEQ); */
+/*   free_iVector(jinb_sav,0, MAXSEQ); */
 
- free_dMatrix(s,0,rows-1,0,cols-1);
- free_dMatrix(SS,0,rows-1,0,cols-1);
- free_dMatrix(TrRow,0,rows-1,0,cols-1);
- free_dMatrix(TrCol,0,rows-1,0,cols-1);
- free_iVector(jOpnPen,0, cols-1);
- free_iVector(jExtPen,0, cols-1);
- free_iVector(iOpnPen,0, rows-1);
- free_iVector(iExtPen,0, rows-1);
+/*   free_dMatrix(s,0,rows-1,0,cols-1); */
+/*  free_dMatrix(SS,0,rows-1,0,cols-1); */
+/*  free_dMatrix(TrRow,0,rows-1,0,cols-1); */
+/*  free_dMatrix(TrCol,0,rows-1,0,cols-1); */
+/*  free_iVector(jOpnPen,0, cols-1); */
+/*  free_iVector(jExtPen,0, cols-1); */
+/*  free_iVector(iOpnPen,0, rows-1); */
+/*  free_iVector(iExtPen,0, rows-1); */
 
- free_dMatrix(x_que,1,3,0,rows-1);
- free_dMatrix(x_que_sav,1,3,0,rows-1);
- free_dMatrix(x_que_original,1,3,0,rows-1);
- free_dMatrix(x_tar,1,3,0,cols-1);
+/*  free_dMatrix(x_que,1,3,0,rows-1); */
+/*  free_dMatrix(x_que_sav,1,3,0,rows-1); */
+/*  free_dMatrix(x_que_original,1,3,0,rows-1); */
+/*  free_dMatrix(x_tar,1,3,0,cols-1); */
 
- free_cVector(a_que,0,rows-1);
- free_cVector(a_tar,0,cols-1);
+/*  free_cVector(a_que,0,rows-1); */
+/*  free_cVector(a_tar,0,cols-1); */
 
- free_cVector(s1,1,StringMax);
- free_cVector(s2,1,StringMax);
- free_cVector(s3,1,StringMax);
- free_cVector(s4,1,StringMax);
+/*  free_cVector(s1,1,StringMax); */
+/*  free_cVector(s2,1,StringMax); */
+/*  free_cVector(s3,1,StringMax); */
+/*  free_cVector(s4,1,StringMax); */
 
- free_cMatrix(aa_que,0,rows-1,0,2);
- free_cMatrix(aa_tar,0,cols-1,0,2);
+/*  free_cMatrix(aa_que,0,rows-1,0,2); */
+/*  free_cMatrix(aa_tar,0,cols-1,0,2); */
 
  /* freeing memory from PMI alignment: */
- free_dVector(Tcm,1,3);
- free_dVector(Tzero,1,3);
- free_dVector(TMPvec,1,3);
- free_dVector(Tcm_que,1,3);
- free_dVector(Tcm_tar,1,3);
- free_dMatrix(Rtemp,1,3,1,3);
- free_dMatrix(Runity,1,3,1,3);
+/*  free_dVector(Tcm,1,3); */
+/*  free_dVector(Tzero,1,3); */
+/*  free_dVector(TMPvec,1,3); */
+/*  free_dVector(Tcm_que,1,3); */ /* not needed */
+/*  free_dVector(Tcm_tar,1,3); */
+/*  free_dMatrix(Rtemp,1,3,1,3); */
+/*  free_dMatrix(Runity,1,3,1,3); */
 
  return 0;
 }
diff -NaurdbB -xCVS lsqrms-2.0.4b.old/src/Makefile.am lsqrms-2.0.4b/src/Makefile.am
--- lsqrms-2.0.4b.old/src/Makefile.am	Sun Apr 20 01:25:04 EDT 2003
+++ lsqrms-2.0.4b/src/Makefile.am	Sun Feb 24 22:49:49 EST 2008
@@ -1,6 +1,6 @@
 bin_PROGRAMS = lsqrms
 AM_LDFLAGS = -lm
-AM_CFLAGS = -Wall -g
+AM_CFLAGS = 
 
 lsqrms_SOURCES = dynapro.c main.c matvecalloc.c matvecutils.c \
  provepdb.c
